/*********************************************************************************
 * ļ  main.c
 *     ͨstm32spi1ȡmax6675¶ֵͨuart1ͳ
 *          
 * ʵƽ̨STM32
 * 汾  ST3.0.0
 * Ӳӣ ------------------------------------
 *           |PA6-SPI1-MISOMAX6675-SO          |
 *           |PA7-SPI1-MOSIMAX6675-SI          |
 *           |PA5-SPI1-SCK MAX6675-SCK         |
 *           |PA4-SPI1-NSS MAX6675-CS          |
 *            ------------------------------------
**********************************************************************************/
#include "stm32f10x.h"
#include "usart1.h"

#define 	MAX6675_CS	 		GPIO_Pin_4
#define 	MAX6675_CSL()		GPIOA->BRR = MAX6675_CS;
#define 	MAX6675_CSH()		GPIOA->BSRR = MAX6675_CS;

/*
 * SPI1_Init
 *   MMAX6675 ӿڳʼ
 *    
 *   
 *   
 */																						  
void SPI_MAX6675_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	SPI_InitTypeDef  SPI_InitStructure;	
	
	/* ʹ SPI1 ʱ */                         
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_SPI1, ENABLE);

	/* ---------ͨI/Oʼ----------------
	 * PA5-SPI1-SCK :MAX6675_SCK
	 * PA6-SPI1-MISO:MAX6675_SO
	 * PA7-SPI1-MOSI:MAX6675_SI	 
	 */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;			// 
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	/* ---------I/Oʼ----------------*/
	/* PA4-SPI1-NSS:MAX6675_CS */							// Ƭѡ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_10MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;		// 
	GPIO_Init(GPIOA, &GPIO_InitStructure);						  
	GPIO_SetBits(GPIOA, GPIO_Pin_4);						// ȰƬѡߣõʱ
 

	/* SPI1  */ 
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_Low;
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_8;
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;
	SPI_InitStructure.SPI_CRCPolynomial = 7;
	SPI_Init(SPI1, &SPI_InitStructure);
	
	
	/* ʹ SPI1  */
	SPI_Cmd(SPI1, ENABLE); 
}

/*
 *
 *
 *
 */
unsigned char MAX6675_ReadByte(void)
{
	
	/* Loop while DR register in not emplty */
	while(SPI_I2S_GetFlagStatus(SPI1,SPI_I2S_FLAG_TXE) == RESET);
	
	/* Send byte through the SPI1 peripheral */
	SPI_I2S_SendData(SPI1, 0xff);
	
	/* Wait to receive a byte */
	while(SPI_I2S_GetFlagStatus(SPI1, SPI_I2S_FLAG_RXNE) == RESET);
	
	/* Return the byte read from the SPI bus */
	return SPI_I2S_ReceiveData(SPI1);
}
/*
 * main
 *   
 *   
 *   	
 */
main (void)
{
	unsigned int t,i;
	unsigned char c;
	unsigned char flag;
	float temprature;
	/* ϵͳʱΪ72M */
	SystemInit();
  
	/* MAX6675 SPI ӿڳʼ */
	SPI_MAX6675_Init();
	USART1_Config();
	
	while(1)
	{
	
		MAX6675_CSL();
		c = MAX6675_ReadByte();
		i = c;
		i = i<<8;
		c = MAX6675_ReadByte();
		MAX6675_CSH();
		
		i = i|((unsigned int)c);			//iǶԭʼ
		flag = i&0x04;						//flagȵż״̬
		t = i<<1;
		t = t>>4;
		temprature = t*0.25;
		if(i!=0)							//max6675ݷ
		{
			if(flag==0)						//ȵż
			{
				printf("ԭʼǣ%04X,  ǰ¶ǣ%4.2f\r\n",i,temprature);
			}	
			else							//ȵż
			{
				printf("δ⵽ȵż顣\r\n");
			}
		
		}
		else								//max6675ûݷ
		{
			printf("max6675ûݷأmax6675ӡ\r\n");
		}
		for(i=0;i<0x2fffff;i++);			//max6675תʱ0.2ңתҪ̫
	}
}



